<?php

function profiler( $return = false )
{
  static $oldSec = 0;
  static $oldUsec = 0;
  static $ret = array();
  
  if( $return )
    return $ret;

  $stack = debug_backtrace();
  list( $newUsec, $newSec ) = explode( ' ', microtime() );
  $sec = ((float)$newSec-(float)$oldSec);
  $usec = ((float)$newUsec-(float)$oldUsec);
  $diff = $usec + $sec;
  $file = $stack[0]['file'];
  $line = $stack[0]['line'];
  if( ! isset( $ret[$file] ) )
  {
    $ret[$file] = array();
  }
  $ret[$file][$line] = ( isset( $ret[$file][$line] ) ? $ret[$file][$line] + $diff : $diff );
  
  list( $oldUsec, $oldSec ) = explode( ' ', microtime() );
  
}
  
if( $_SERVER['argv'][1] != '' )
  $script = $_SERVER['argv'][1];
elseif( $_GET['script'] != '' )
  $script = $_GET['script'];
else
  die( 'Devi inserire il nome dello script da profilare' );



$functions = get_defined_functions();
$functions = $functions['user'];

register_tick_function( 'profiler' );
declare(ticks=1);

ob_start();
require_once( $script );
ob_end_clean();
$info = profiler( true );

?>
<html><body>
<?php

foreach( $info as $file => $value )
{
  if ( strstr( $file, 'eval' ) || ( substr( $file, -12 ) == 'register.php' ) )
    continue;
  echo "<hr/><h2>$file</h2>";
  $file = fopen ( $file, "r" );
  $n = 1;
  while( ! feof( $file ) )
  {
    $n++;
    $line = trim ( fgets( $file, 1024 ) );
    if ( ! isset( $value[$n] ) )
    {
      echo "<span style='color: #333; font-size: 10px'>$n: " . htmlentities( $line ) . "</span><br/>";
      continue;
    }

    $col = sprintf( "%d", log( $value[$n]*1000000 ) ) ;
    $col += 10;
    echo "{$value[$n]} <span style='font-size: ${col}px'>$n: $line</span><br/>";
  }
  fclose( $file );
}

?>
</body></html>